/*----- PROTECTED REGION ID(Standa8SMC4.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Standa8SMC4.cpp,v 1.5 2016-11-11 09:39:26 graziano Exp $";
//=============================================================================
//
// file :        Standa8SMC4.cpp
//
// description : C++ source for the Standa8SMC4 class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Standa8SMC4 are implemented in this file.
//
// project :     Standa 8SMC4
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: graziano $
//
// $Revision: 1.5 $
// $Date: 2016-11-11 09:39:26 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Standa8SMC4.h>
#include <Standa8SMC4Class.h>

//#include "standathread.h"
#include "ximc.h"
#include <math.h>

/*----- PROTECTED REGION END -----*/	//	Standa8SMC4.cpp

/**
 *  Standa8SMC4 class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//  Forward       |  forward
//  Backward      |  backward
//  Stop          |  stop
//  MotorOFF      |  motor_off
//  MotorON       |  motor_on
//  MotorSTANDBY  |  motor_standby
//  GoHome        |  go_home
//  SetHome       |  set_home
//  GoToPosition  |  go_to_position
//  FindEdge      |  find_edge
//  SetHomeValue  |  set_home_value
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  Position       |  Tango::DevDouble	Scalar
//  Acceleration   |  Tango::DevDouble	Scalar
//  Accuracy       |  Tango::DevDouble	Scalar
//  Position_home  |  Tango::DevDouble	Scalar
//  Stat           |  Tango::DevLong	Scalar
//  EdgesStatus    |  Tango::DevString	Scalar
//  HomingConfig   |  Tango::DevString	Scalar
//  Serialdevice   |  Tango::DevString	Scalar
//  SerialNumber   |  Tango::DevLong	Scalar
//  StageName      |  Tango::DevString	Scalar
//  Speed          |  Tango::DevDouble	Spectrum  ( max = 2)
//================================================================

namespace Standa8SMC4_ns
{
/*----- PROTECTED REGION ID(Standa8SMC4::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::Standa8SMC4()
 *	Description : Constructors for a Tango device
 *                implementing the classStanda8SMC4
 */
//--------------------------------------------------------
Standa8SMC4::Standa8SMC4(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Standa8SMC4::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::constructor_1
}
//--------------------------------------------------------
Standa8SMC4::Standa8SMC4(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(Standa8SMC4::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::constructor_2
}
//--------------------------------------------------------
Standa8SMC4::Standa8SMC4(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(Standa8SMC4::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Standa8SMC4::delete_device()
{
	DEBUG_STREAM << "Standa8SMC4::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects

	//DEBUG_STREAM << "Standa8SMC3::delete_device() before delete devserial"<<endl;
	close_device(&this->device);
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::delete_device
	delete[] attr_Position_read;
	delete[] attr_Acceleration_read;
	delete[] attr_Accuracy_read;
	delete[] attr_Position_home_read;
	delete[] attr_Stat_read;
	delete[] attr_EdgesStatus_read;
	delete[] attr_HomingConfig_read;
	delete[] attr_Serialdevice_read;
	delete[] attr_SerialNumber_read;
	delete[] attr_StageName_read;
	delete[] attr_Speed_read;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void Standa8SMC4::init_device()
{
	DEBUG_STREAM << "Standa8SMC4::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	clock_gettime(CLOCK_MONOTONIC,&lastconnection);
	lastconnection.tv_sec -= 10;
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::init_device_before
	

	//	Get the device properties from database
	get_device_property();
	
	attr_Position_read = new Tango::DevDouble[1];
	attr_Acceleration_read = new Tango::DevDouble[1];
	attr_Accuracy_read = new Tango::DevDouble[1];
	attr_Position_home_read = new Tango::DevDouble[1];
	attr_Stat_read = new Tango::DevLong[1];
	attr_EdgesStatus_read = new Tango::DevString[1];
	attr_HomingConfig_read = new Tango::DevString[1];
	attr_Serialdevice_read = new Tango::DevString[1];
	attr_SerialNumber_read = new Tango::DevLong[1];
	attr_StageName_read = new Tango::DevString[1];
	attr_Speed_read = new Tango::DevDouble[2];
	/*----- PROTECTED REGION ID(Standa8SMC4::init_device) ENABLED START -----*/
	
	//	Initialize device
	serial_num = -1;
	if(serialNumber.length() > 0)
	{
		if(serialNumber.find("0x") != string::npos || serialNumber.find("0X") != string::npos)
			serial_num = strtoul(serialNumber.c_str(), NULL, 16);
		else
			serial_num = strtoul(serialNumber.c_str(), NULL, 10);
	}
	edgestatus.str(string(""));
	strcpy(edgestatus_str, edgestatus.str().c_str());
	attr_EdgesStatus_read[0] = (char *)edgestatus_str;
	homesetting.str(string(""));
	strcpy(homesetting_str, homesetting.str().c_str());
	attr_HomingConfig_read[0] = (char *)homesetting_str;
	strcpy(serialdevice_str, "None");
	attr_Serialdevice_read[0] = (char *)serialdevice_str;
	*attr_SerialNumber_read = -1;
	strcpy(stagename_str, "");
	attr_StageName_read[0] = (char *)stagename_str;
	device = device_undefined;
	connect_device();

	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::init_device
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void Standa8SMC4::get_device_property()
{
	/*----- PROTECTED REGION ID(Standa8SMC4::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("AxisNumber"));
	dev_prop.push_back(Tango::DbDatum("AxisForwardLimit"));
	dev_prop.push_back(Tango::DbDatum("AxisBackwardLimit"));
	dev_prop.push_back(Tango::DbDatum("Serialdevice"));
	dev_prop.push_back(Tango::DbDatum("Serial_timeout"));
	dev_prop.push_back(Tango::DbDatum("Wr_sleep"));
	dev_prop.push_back(Tango::DbDatum("Th_sleep"));
	dev_prop.push_back(Tango::DbDatum("PositionRatio"));
	dev_prop.push_back(Tango::DbDatum("Current_position"));
	dev_prop.push_back(Tango::DbDatum("Limit_switch_polarity"));
	dev_prop.push_back(Tango::DbDatum("SerialNumber"));
	dev_prop.push_back(Tango::DbDatum("StageName"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on Standa8SMC4Class to get class property
		Tango::DbDatum	def_prop, cl_prop;
		Standa8SMC4Class	*ds_class =
			(static_cast<Standa8SMC4Class *>(get_device_class()));
		int	i = -1;

		//	Try to initialize AxisNumber from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  axisNumber;
		else {
			//	Try to initialize AxisNumber from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  axisNumber;
		}
		//	And try to extract AxisNumber value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  axisNumber;

		//	Try to initialize AxisForwardLimit from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  axisForwardLimit;
		else {
			//	Try to initialize AxisForwardLimit from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  axisForwardLimit;
		}
		//	And try to extract AxisForwardLimit value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  axisForwardLimit;

		//	Try to initialize AxisBackwardLimit from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  axisBackwardLimit;
		else {
			//	Try to initialize AxisBackwardLimit from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  axisBackwardLimit;
		}
		//	And try to extract AxisBackwardLimit value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  axisBackwardLimit;

		//	Try to initialize Serialdevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  serialdevice;
		else {
			//	Try to initialize Serialdevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  serialdevice;
		}
		//	And try to extract Serialdevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  serialdevice;

		//	Try to initialize Serial_timeout from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  serial_timeout;
		else {
			//	Try to initialize Serial_timeout from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  serial_timeout;
		}
		//	And try to extract Serial_timeout value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  serial_timeout;

		//	Try to initialize Wr_sleep from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  wr_sleep;
		else {
			//	Try to initialize Wr_sleep from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  wr_sleep;
		}
		//	And try to extract Wr_sleep value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  wr_sleep;

		//	Try to initialize Th_sleep from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  th_sleep;
		else {
			//	Try to initialize Th_sleep from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  th_sleep;
		}
		//	And try to extract Th_sleep value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  th_sleep;

		//	Try to initialize PositionRatio from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  positionRatio;
		else {
			//	Try to initialize PositionRatio from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  positionRatio;
		}
		//	And try to extract PositionRatio value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  positionRatio;

		//	Try to initialize Current_position from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  current_position;
		else {
			//	Try to initialize Current_position from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  current_position;
		}
		//	And try to extract Current_position value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  current_position;

		//	Try to initialize Limit_switch_polarity from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  limit_switch_polarity;
		else {
			//	Try to initialize Limit_switch_polarity from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  limit_switch_polarity;
		}
		//	And try to extract Limit_switch_polarity value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  limit_switch_polarity;

		//	Try to initialize SerialNumber from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  serialNumber;
		else {
			//	Try to initialize SerialNumber from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  serialNumber;
		}
		//	And try to extract SerialNumber value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  serialNumber;

		//	Try to initialize StageName from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  stageName;
		else {
			//	Try to initialize StageName from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  stageName;
		}
		//	And try to extract StageName value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  stageName;

	}

	/*----- PROTECTED REGION ID(Standa8SMC4::get_device_property_after) ENABLED START -----*/
	
	//	Check device property data members init
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::get_device_property_after
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Standa8SMC4::always_executed_hook()
{
	DEBUG_STREAM << "Standa8SMC4::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	if(get_state() == Tango::FAULT)
	{
		close_device(&this->device);
		connect_device();
	}
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Standa8SMC4::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Standa8SMC4::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::read_attr_hardware) ENABLED START -----*/

	//	Add your own code
	result_t results[5];
	results[0] = get_move_settings(this->device, &this->move_settings);
	results[1] = ::get_status(this->device, &this->status);
	results[2] = get_engine_settings(this->device, &this->engine_settings);
	//results[3] = get_chart_data(this->device, &this->chart_data);
	//results[4] = get_device_information(this->device, &this->device_information);

	//for(int i=0; i<5; i++)
	for(int i=0; i<3; i++)
	{
		result_t r=results[i];
		if(r == result_error) {
			this->set_state(Tango::FAULT);
			this->set_status("Result error");
			INFO_STREAM << __func__ << ": i="<<i<<" Result error";
			return;
		} else if(r == result_nodevice) {
			this->set_state(Tango::FAULT);
			this->set_status("Result nodevice");
			INFO_STREAM << __func__ << ": i="<<i<<" Result nodevice";
			return;
		} else if(r == result_value_error) {
			this->set_state(Tango::FAULT);
			this->set_status("Result value error");
			INFO_STREAM << __func__ << ": i="<<i<<" Result value error";
			return;
		} else if(r == result_not_implemented) {
			this->set_state(Tango::FAULT);
			this->set_status("Result not implemented");
			INFO_STREAM << __func__ << ": i="<<i<<" Result not implemented";
			return;
		}
	}
	//DEBUG_STREAM << __func__ << ": Speed="<<move_settings.Speed << " CurPosition="<<status.CurPosition;
	attr_Speed_read[0] = (Tango::DevDouble)this->move_settings.Speed;
	attr_Speed_read[1] = (Tango::DevDouble)this->move_settings.Speed;	//TODO: !!
	*attr_Acceleration_read = (Tango::DevDouble)this->move_settings.Accel;
	*attr_Accuracy_read = (Tango::DevDouble)this->engine_settings.MicrostepMode;

	*attr_Position_read = ((Tango::DevDouble)this->status.CurPosition + (Tango::DevDouble)(this->status.uCurPosition/pow(2,*attr_Accuracy_read-1)))/positionRatio;
	*attr_Stat_read = this->status.MoveSts;
	if(this->status.Flags & STATE_ALARM)
	{
		set_state(Tango::ALARM);
		set_status("Controller is in alarm state - STOP command to reset");
	}
	else if(this->status.Flags & STATE_POWER_OVERHEAT)
	{
		set_state(Tango::ALARM);
		set_status("Power driver overheat");
	}
	else if(this->status.Flags & STATE_CONTROLLER_OVERHEAT)
	{
		set_state(Tango::ALARM);
		set_status("Controller overheat");
	}
	else if(this->status.Flags & STATE_OVERLOAD_POWER_VOLTAGE)
	{
		set_state(Tango::ALARM);
		set_status("Power voltage exceeds safe limit");
	}
	else if(this->status.Flags & STATE_OVERLOAD_POWER_CURRENT)
	{
		set_state(Tango::ALARM);
		set_status("Power current exceeds safe limit");
	}
	else if(this->status.Flags & STATE_OVERLOAD_USB_VOLTAGE)
	{
		set_state(Tango::ALARM);
		set_status("USB voltage exceeds safe limit");
	}
	else if(this->status.Flags & STATE_LOW_USB_VOLTAGE)
	{
		set_state(Tango::ALARM);
		set_status("USB voltage is insufficient for normal operation");
	}
	else if(this->status.Flags & STATE_OVERLOAD_USB_CURRENT)
	{
		set_state(Tango::ALARM);
		set_status("USB current exceeds safe limit");
	}
	else if(this->status.Flags & STATE_LOW_POWER_VOLTAGE )
	{
		set_state(Tango::ALARM);
		set_status("Power voltage is lower than Low Voltage Protection limit");
	}
	else if(this->status.Flags & STATE_BORDERS_SWAP_MISSET)
	{
		set_state(Tango::ALARM);
		set_status("Engine stuck at the wrong edge");
	}
	else if(this->status.Flags & STATE_CTP_ERROR)
	{
		set_state(Tango::ALARM);
		set_status("Control position error");
	}
	else if(this->status.MoveSts & MOVE_STATE_MOVING)
	{
		set_state(Tango::MOVING);
		if(this->status.MoveSts & MOVE_STATE_TARGET_SPEED)
			set_status("Moving - Target speed is reached");
		else if(this->status.MoveSts & MOVE_STATE_ANTIPLAY)
			set_status("Moving - Motor is playing compensation");
		else
			set_status("Moving");
	}
	else if(this->status.PWRSts & PWR_STATE_OFF)
	{
		set_state(Tango::OFF);
		set_status("Motor windings are disconnected from the driver");
	}
	else if(this->status.PWRSts & PWR_STATE_REDUCT )
	{
		set_state(Tango::STANDBY);
		set_status("Motor windings are powered by reduced current to lower power consumption");
	}
	else
	{
		set_state(Tango::ON);
		/*if(this->status.Flags & STATE_IS_HOMED)
			set_status("Homing performed");
		else
			set_status("Homing NOT performed");*/
		set_status("");
	}
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void Standa8SMC4::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Standa8SMC4::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute Position related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Standa8SMC4::read_Position(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::read_Position(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::read_Position) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Position_read);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::read_Position
}
//--------------------------------------------------------
/**
 *	Write attribute Position related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Standa8SMC4::write_Position(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::write_Position(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Standa8SMC4::write_Position) ENABLED START -----*/
	
	go_to_position(w_val);
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::write_Position
}
//--------------------------------------------------------
/**
 *	Read attribute Acceleration related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Standa8SMC4::read_Acceleration(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::read_Acceleration(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::read_Acceleration) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Acceleration_read);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::read_Acceleration
}
//--------------------------------------------------------
/**
 *	Write attribute Acceleration related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Standa8SMC4::write_Acceleration(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::write_Acceleration(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Standa8SMC4::write_Acceleration) ENABLED START -----*/
	
	get_move_settings(this->device, &this->move_settings);
	this->move_settings.Accel = static_cast<unsigned int>(w_val);
	set_move_settings(this->device, &this->move_settings);
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::write_Acceleration
}
//--------------------------------------------------------
/**
 *	Read attribute Accuracy related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Standa8SMC4::read_Accuracy(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::read_Accuracy(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::read_Accuracy) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Accuracy_read);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::read_Accuracy
}
//--------------------------------------------------------
/**
 *	Write attribute Accuracy related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Standa8SMC4::write_Accuracy(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::write_Accuracy(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Standa8SMC4::write_Accuracy) ENABLED START -----*/
	get_engine_settings(this->device, &this->engine_settings);
	this->engine_settings.MicrostepMode = static_cast<uint8_t>(w_val);
	set_engine_settings(this->device, &this->engine_settings);
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::write_Accuracy
}
//--------------------------------------------------------
/**
 *	Read attribute Position_home related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Standa8SMC4::read_Position_home(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::read_Position_home(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::read_Position_home) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Position_home_read);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::read_Position_home
}
//--------------------------------------------------------
/**
 *	Write attribute Position_home related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Standa8SMC4::write_Position_home(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::write_Position_home(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Standa8SMC4::write_Position_home) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::write_Position_home
}
//--------------------------------------------------------
/**
 *	Read attribute Stat related method
 *	Description: 0=standby\n1=moving\n2=resetting to left\n3=resetting to right
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Standa8SMC4::read_Stat(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::read_Stat(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::read_Stat) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Stat_read);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::read_Stat
}
//--------------------------------------------------------
/**
 *	Read attribute EdgesStatus related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Standa8SMC4::read_EdgesStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::read_EdgesStatus(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::read_EdgesStatus) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_EdgesStatus_read);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::read_EdgesStatus
}
//--------------------------------------------------------
/**
 *	Read attribute HomingConfig related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Standa8SMC4::read_HomingConfig(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::read_HomingConfig(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::read_HomingConfig) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_HomingConfig_read);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::read_HomingConfig
}
//--------------------------------------------------------
/**
 *	Read attribute Serialdevice related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Standa8SMC4::read_Serialdevice(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::read_Serialdevice(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::read_Serialdevice) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Serialdevice_read);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::read_Serialdevice
}
//--------------------------------------------------------
/**
 *	Read attribute SerialNumber related method
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Standa8SMC4::read_SerialNumber(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::read_SerialNumber(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::read_SerialNumber) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_SerialNumber_read);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::read_SerialNumber
}
//--------------------------------------------------------
/**
 *	Read attribute StageName related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Standa8SMC4::read_StageName(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::read_StageName(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::read_StageName) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_StageName_read);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::read_StageName
}
//--------------------------------------------------------
/**
 *	Read attribute Speed related method
 *	Description: double[0]: min speed\ndouble[1]: max speed
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 2
 */
//--------------------------------------------------------
void Standa8SMC4::read_Speed(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::read_Speed(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::read_Speed) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Speed_read, 2);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::read_Speed
}
//--------------------------------------------------------
/**
 *	Write attribute Speed related method
 *	Description: double[0]: min speed\ndouble[1]: max speed
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 2
 */
//--------------------------------------------------------
void Standa8SMC4::write_Speed(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Standa8SMC4::write_Speed(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve number of write values
	int	w_length = attr.get_write_value_length();

	//	Retrieve pointer on write values (Do not delete !)
	const Tango::DevDouble	*w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Standa8SMC4::write_Speed) ENABLED START -----*/
	get_move_settings(this->device, &this->move_settings);
	this->move_settings.Speed = static_cast<unsigned int>(w_val[0]);
	set_move_settings(this->device, &this->move_settings);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::write_Speed
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Standa8SMC4::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Standa8SMC4::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command Forward related method
 *	Description: 
 *
 *	@param argin 
 */
//--------------------------------------------------------
void Standa8SMC4::forward(Tango::DevDouble argin)
{
	DEBUG_STREAM << "Standa8SMC4::Forward()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::forward) ENABLED START -----*/
	
	//	Add your own code
	if(*attr_Position_read+argin > axisForwardLimit)
	{
		stringstream tmp;
		tmp << "Requested " << *attr_Position_read+argin << "! Out of range ["<<axisBackwardLimit<<","<<axisForwardLimit<<"]";
		Tango::Except::throw_exception(
					(const char *) "Out of Range",
					tmp.str(),
					(const char *) __func__, Tango::ERR);
	}
	double position_dev = argin * positionRatio;
	double dposition;
	double duposition;
	duposition = modf (position_dev , &dposition);
	int iposition = static_cast<int>(dposition);
	int iuposition = static_cast<int>(round(duposition * pow(2,(*attr_Accuracy_read-1))));
	DEBUG_STREAM << __func__<<": requested="<<argin<<" -> " <<position_dev<<" steps="<<iposition<<" usteps="<<iuposition;
	command_movr(this->device, iposition, iuposition);
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::forward
}
//--------------------------------------------------------
/**
 *	Command Backward related method
 *	Description: 
 *
 *	@param argin 
 */
//--------------------------------------------------------
void Standa8SMC4::backward(Tango::DevDouble argin)
{
	DEBUG_STREAM << "Standa8SMC4::Backward()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::backward) ENABLED START -----*/
	
	//	Add your own code
	if(*attr_Position_read-argin < axisBackwardLimit)
	{
		stringstream tmp;
		tmp << "Requested " << *attr_Position_read-argin << "! Out of range ["<<axisBackwardLimit<<","<<axisForwardLimit<<"]";
		Tango::Except::throw_exception(
					(const char *) "Out of Range",
					tmp.str(),
					(const char *) __func__, Tango::ERR);
	}
	double position_dev = argin * positionRatio;
	double dposition;
	double duposition;
	duposition = modf (position_dev , &dposition);
	int iposition = static_cast<int>(dposition);
	int iuposition = static_cast<int>(round(duposition * pow(2,(*attr_Accuracy_read-1))));
	DEBUG_STREAM << __func__<<": requested="<<argin<<" -> " <<position_dev<<" steps="<<iposition<<" usteps="<<iuposition;
	command_movr(this->device, -iposition, -iuposition);
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::backward
}
//--------------------------------------------------------
/**
 *	Command Stop related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Standa8SMC4::stop()
{
	DEBUG_STREAM << "Standa8SMC4::Stop()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::stop) ENABLED START -----*/
	
	//	Add your own code
	//command_stop(this->device);//stop immediately
	command_sstp(this->device);	//stop with deceleration
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::stop
}
//--------------------------------------------------------
/**
 *	Command MotorOFF related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Standa8SMC4::motor_off()
{
	DEBUG_STREAM << "Standa8SMC4::MotorOFF()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::motor_off) ENABLED START -----*/
	
	//	Add your own code
	command_power_off(this->device);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::motor_off
}
//--------------------------------------------------------
/**
 *	Command MotorON related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Standa8SMC4::motor_on()
{
	DEBUG_STREAM << "Standa8SMC4::MotorON()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::motor_on) ENABLED START -----*/
	
	//	Add your own code
//TODO	command_power_on(this->device);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::motor_on
}
//--------------------------------------------------------
/**
 *	Command MotorSTANDBY related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Standa8SMC4::motor_standby()
{
	DEBUG_STREAM << "Standa8SMC4::MotorSTANDBY()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::motor_standby) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::motor_standby
}
//--------------------------------------------------------
/**
 *	Command GoHome related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Standa8SMC4::go_home()
{
	DEBUG_STREAM << "Standa8SMC4::GoHome()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::go_home) ENABLED START -----*/
	
	//	Add your own code
	command_home(this->device);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::go_home
}
//--------------------------------------------------------
/**
 *	Command SetHome related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Standa8SMC4::set_home()
{
	DEBUG_STREAM << "Standa8SMC4::SetHome()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::set_home) ENABLED START -----*/
	
	//	Add your own code
	//set current position as 0
	set_position_t the_set_position;
	the_set_position.Position=0;
	the_set_position.uPosition=0;
	the_set_position.EncPosition=0;
	the_set_position.PosFlags=0;
	set_position (device, &the_set_position);
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::set_home
}
//--------------------------------------------------------
/**
 *	Command GoToPosition related method
 *	Description: 
 *
 *	@param argin absolute position in user units
 */
//--------------------------------------------------------
void Standa8SMC4::go_to_position(Tango::DevDouble argin)
{
	DEBUG_STREAM << "Standa8SMC4::GoToPosition()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::go_to_position) ENABLED START -----*/
	
	//	Add your own code
	if(argin > axisForwardLimit || argin < axisBackwardLimit)
	{
		stringstream tmp;
		tmp << "Requested " << argin << "! Out of range ["<<axisBackwardLimit<<","<<axisForwardLimit<<"]";
		Tango::Except::throw_exception(
					(const char *) "Out of Range",
					tmp.str(),
					(const char *) __func__, Tango::ERR);
	}
	double position_dev = argin * positionRatio;
	double dposition;
	double duposition;
	duposition = modf (position_dev , &dposition);
	int iposition = static_cast<int>(dposition);
	int iuposition = static_cast<int>(round(duposition * pow(2,(*attr_Accuracy_read-1))));
	DEBUG_STREAM << __func__<<": requested="<<argin<<" -> " <<position_dev<<" steps="<<iposition<<" usteps="<<iuposition;
	command_move(this->device, iposition, iuposition);
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::go_to_position
}
//--------------------------------------------------------
/**
 *	Command FindEdge related method
 *	Description: 
 *
 *	@param argin 0=find left limit switch 1=find right limit switch
 */
//--------------------------------------------------------
void Standa8SMC4::find_edge(Tango::DevLong argin)
{
	DEBUG_STREAM << "Standa8SMC4::FindEdge()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::find_edge) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::find_edge
}
//--------------------------------------------------------
/**
 *	Command SetHomeValue related method
 *	Description: Set current Position as argin
 *
 *	@param argin Actual Position
 */
//--------------------------------------------------------
void Standa8SMC4::set_home_value(Tango::DevDouble argin)
{
	DEBUG_STREAM << "Standa8SMC4::SetHomeValue()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Standa8SMC4::set_home_value) ENABLED START -----*/
	
	//	Add your own code
	//set current position as 0
	set_position_t the_set_position;
	the_set_position.Position=argin*positionRatio;
	the_set_position.uPosition=0;
	the_set_position.EncPosition=argin*positionRatio;
	the_set_position.PosFlags=0;
	set_position (device, &the_set_position);
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::set_home_value
}
//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void Standa8SMC4::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(Standa8SMC4::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::add_dynamic_commands
}

/*----- PROTECTED REGION ID(Standa8SMC4::namespace_ending) ENABLED START -----*/

//	Additional Methods
void Standa8SMC4::connect_device()
{
	timespec now;
	clock_gettime(CLOCK_MONOTONIC,&now);
	double dlast_conn = now.tv_sec - lastconnection.tv_sec + ((double)now.tv_nsec - lastconnection.tv_nsec)/1000000000.0;
	DEBUG_STREAM << "Standa8SMC4::"<<__func__<<": entering, time since last connection="<<dlast_conn << endl;
	if(dlast_conn < 3)
	{
		return;
	}
	clock_gettime(CLOCK_MONOTONIC,&lastconnection);
	//serialdevice=xi-com:///dev/ximc/00000000 works only with original library
	if(serialdevice.find("ximc") != string::npos)
	{
		std::stringstream stream;
		stream << std::uppercase << std::hex << serial_num;
		std::string serial(stream.str());
		//std::string path("xi-com:///dev/ximc/00000000");
		std::string path(serialdevice);
		assert(serial.length() <= 8);
		path.replace(path.end()-serial.length(), path.end(), serial);
		this->device = open_device(path.data());
		if(this->device != device_undefined)
			strcpy(serialdevice_str, path.c_str());
		DEBUG_STREAM << __func__<<": opening " << path<<" device=0x"<<hex << device<<dec;
	}
	//serialdevice=/dev/ttyACM works only with my minimal library, attached via USB, looks for serial_num in /dev/ttyACM*
	else if(serialdevice.find("ACM") != string::npos)
	{
		for(int i=0; i<MAX_DEVICES; i++)
		{
			stringstream tmp;
			tmp << string("/dev/ttyACM")<<i;
			string path=tmp.str();
			this->device = open_device(path.data());
			DEBUG_STREAM << __func__<<": opening " << path<<" device=0x"<<hex << device<<dec;
			if(this->device != device_undefined)
			{
				unsigned int serial_number=0;
				result_t result_ser = get_serial_number(this->device, &serial_number);
				stage_name_t stage_name;
				result_t result_name = get_stage_name (this->device, &stage_name);

				if(stageName.length() > 0 && result_name == result_ok && string(stage_name.PositionerName) == stageName)
				{
					DEBUG_STREAM << __func__<<": FOUND stage_name='" << stage_name.PositionerName<<"'";
					strcpy(serialdevice_str, path.c_str());
					*attr_SerialNumber_read = serial_number;
					strcpy(stagename_str, stage_name.PositionerName);
					break;
				}
				else if(stageName.length() == 0 && serialNumber.length() > 0 && result_ser == result_ok && serial_number == serial_num)
				{
					DEBUG_STREAM << __func__<<": FOUND serial_number=0x" <<hex<< serial_number<<dec<<"->"<<serial_number;
					strcpy(serialdevice_str, path.c_str());
					*attr_SerialNumber_read = serial_number;
					strcpy(stagename_str, stage_name.PositionerName);
					break;
				}
				else if(result_name == result_ok && result_ser == result_ok)
				{
					DEBUG_STREAM << __func__<<": looking for stageName='"<<stageName<<"' now '"<<stage_name.PositionerName<<"' serial_number 0x" <<hex<< serial_num<<dec<<"->"<<serial_num<<" now 0x" <<hex<< serial_number<<dec<<"->"<<serial_number;
					close_device(&this->device);
				}
				else
				{
					DEBUG_STREAM << __func__<<": ERROR READING ("<<result_name<<","<<result_ser<<") looking for stageName='"<<stageName<<"' serial_number 0x" <<hex<< serial_num<<dec<<"->"<<serial_num;
					close_device(&this->device);
				}
			}
		}
	}
	//serialdevice=/dev/tty* works only with my minimal library, attached via SERIAL, or USB with proper udev rules, open only the specified port
	else
	{
		this->device = open_device(serialdevice.data());
		DEBUG_STREAM << __func__<<": opening " << serialdevice<<" device=0x"<<hex << device<<dec;
		if(this->device != device_undefined)
		{
			strcpy(serialdevice_str, serialdevice.c_str());
			unsigned int serial_number=0;
			result_t result_ser = get_serial_number(this->device, &serial_number);
			stage_name_t stage_name;
			result_t result_name = get_stage_name (this->device, &stage_name);
			if(result_ser == result_ok && result_name == result_ok)
			{
				*attr_SerialNumber_read = serial_number;
				strcpy(stagename_str, stage_name.PositionerName);
			}
		}
	}


	result_t results[4];
	results[0] = ::get_status(this->device, &this->status);
	results[1] = ::get_edges_settings(this->device, &this->edges_settings);
	results[2] = get_engine_settings(this->device, &this->engine_settings);
	results[3] = get_home_settings(this->device, &this->home_settings);
	//results[4] = get_device_information(this->device, &this->device_information);

	//for(int i=0; i<5; i++)
	for(int i=0; i<4; i++)
	{
		result_t r=results[i];
		if(r == result_error) {
			this->set_state(Tango::FAULT);
			this->set_status("Result error");
			INFO_STREAM << __func__ << ": get_status -> Result error";
			return;
		} else if(r == result_nodevice) {
			this->set_state(Tango::FAULT);
			this->set_status("Result nodevice");
			INFO_STREAM << __func__ << ": get_status ->  Result nodevice";
			return;
		} else if(r == result_value_error) {
			this->set_state(Tango::FAULT);
			this->set_status("Result value error");
			INFO_STREAM << __func__ << ": get_status ->  Result value error";
			return;
		} else if(r == result_not_implemented) {
			this->set_state(Tango::FAULT);
			this->set_status("Result not implemented");
			INFO_STREAM << __func__ << ": get_status ->  Result not implemented";
			return;
		}
	}

	//DEBUG_STREAM << __func__ << ": Speed="<<move_settings.Speed << " CurPosition="<<status.CurPosition;
	*attr_Accuracy_read = (Tango::DevDouble)this->engine_settings.MicrostepMode;
	edgestatus.str("");
	if(this->edges_settings.BorderFlags & BORDER_IS_ENCODER)
	{
		double backward = ((Tango::DevDouble)this->edges_settings.LeftBorder + (Tango::DevDouble)(this->edges_settings.uLeftBorder/pow(2,*attr_Accuracy_read-1)))/positionRatio;
		double forward = ((Tango::DevDouble)this->edges_settings.RightBorder + (Tango::DevDouble)(this->edges_settings.uRightBorder/pow(2,*attr_Accuracy_read-1)))/positionRatio;
		edgestatus << "Encoder Edge ENABLED ["<<backward<<","<<forward<<"]";
	}
	if(this->edges_settings.BorderFlags & BORDER_STOP_LEFT)
	{
		if(edgestatus.str().length() > 0)
			edgestatus << "; \n";
		edgestatus << "Backward Edge ENABLED";
	}
	if(this->edges_settings.BorderFlags & BORDER_STOP_RIGHT)
	{
		if(edgestatus.str().length() > 0)
			edgestatus << "; \n";
		edgestatus << "Forward Edge ENABLED";
	}
	if(this->edges_settings.BorderFlags & BORDERS_SWAP_MISSET_DETECTION )
	{
		if(edgestatus.str().length() > 0)
			edgestatus << "; \n";
		edgestatus << "Motor should stop on both borders: WRONG SETTING";
	}
	if(this->edges_settings.EnderFlags & ENDER_SWAP)
	{
		if(edgestatus.str().length() > 0)
			edgestatus << "; \n";
		edgestatus << "Forward/Backward Edge SWAPPED";
	}
	if(this->edges_settings.EnderFlags & ENDER_SW1_ACTIVE_LOW )
	{
		if(edgestatus.str().length() > 0)
			edgestatus << "; \n";
		edgestatus << "Limit Switch SW1 triggered by low level";
	}
	else
	{
		if(edgestatus.str().length() > 0)
			edgestatus << "; \n";
		edgestatus << "Limit Switch SW1 triggered by high level";
	}
	if(this->edges_settings.EnderFlags & ENDER_SW2_ACTIVE_LOW )
	{
		if(edgestatus.str().length() > 0)
			edgestatus << "; \n";
		edgestatus << "Limit Switch SW2 triggered by low level";
	}
	else
	{
		if(edgestatus.str().length() > 0)
			edgestatus << "; \n";
		edgestatus << "Limit Switch SW2 triggered by high level";
	}
	strcpy(edgestatus_str, edgestatus.str().c_str());
	//attr_EdgesStatus_read[0] = (char *)edgestatus_str;
	//attr_EdgesStatus_read[0] = (char *)edgestatus.str().data();

	homesetting.str("");
	homesetting << "Fast Speed="<<home_settings.FastHome<<","<<home_settings.uFastHome<<" Slow Speed="<<home_settings.SlowHome<<","<<home_settings.uSlowHome<<" Delta="<<home_settings.HomeDelta<<","<<home_settings.uHomeDelta<<" Flags="<<home_settings.HomeFlags;
	strcpy(homesetting_str, homesetting.str().c_str());

	*attr_Stat_read = this->status.MoveSts;
	if(this->status.Flags & STATE_ALARM)
	{
		set_state(Tango::ALARM);
		set_status("Controller is in alarm state - STOP command to reset");
	}
	else if(this->status.Flags & STATE_POWER_OVERHEAT)
	{
		set_state(Tango::ALARM);
		set_status("Power driver overheat");
	}
	else if(this->status.Flags & STATE_CONTROLLER_OVERHEAT)
	{
		set_state(Tango::ALARM);
		set_status("Controller overheat");
	}
	else if(this->status.Flags & STATE_OVERLOAD_POWER_VOLTAGE)
	{
		set_state(Tango::ALARM);
		set_status("Power voltage exceeds safe limit");
	}
	else if(this->status.Flags & STATE_OVERLOAD_POWER_CURRENT)
	{
		set_state(Tango::ALARM);
		set_status("Power current exceeds safe limit");
	}
	else if(this->status.Flags & STATE_OVERLOAD_USB_VOLTAGE)
	{
		set_state(Tango::ALARM);
		set_status("USB voltage exceeds safe limit");
	}
	else if(this->status.Flags & STATE_LOW_USB_VOLTAGE)
	{
		set_state(Tango::ALARM);
		set_status("USB voltage is insufficient for normal operation");
	}
	else if(this->status.Flags & STATE_OVERLOAD_USB_CURRENT)
	{
		set_state(Tango::ALARM);
		set_status("USB current exceeds safe limit");
	}
	else if(this->status.Flags & STATE_LOW_POWER_VOLTAGE )
	{
		set_state(Tango::ALARM);
		set_status("Power voltage is lower than Low Voltage Protection limit");
	}
	else if(this->status.Flags & STATE_BORDERS_SWAP_MISSET)
	{
		set_state(Tango::ALARM);
		set_status("Engine stuck at the wrong edge");
	}
	else if(this->status.Flags & STATE_CTP_ERROR)
	{
		set_state(Tango::ALARM);
		set_status("Control position error");
	}
	else if(this->status.MoveSts & MOVE_STATE_MOVING)
	{
		set_state(Tango::MOVING);
		if(this->status.MoveSts & MOVE_STATE_TARGET_SPEED)
			set_status("Moving - Target speed is reached");
		else if(this->status.MoveSts & MOVE_STATE_ANTIPLAY)
			set_status("Moving - Motor is playing compensation");
		else
			set_status("Moving");
	}
	else if(this->status.PWRSts & PWR_STATE_OFF)
	{
		set_state(Tango::OFF);
		set_status("Motor windings are disconnected from the driver");
	}
	else if(this->status.PWRSts & PWR_STATE_REDUCT )
	{
		set_state(Tango::STANDBY);
		set_status("Motor windings are powered by reduced current to lower power consumption");
	}
	else
	{
		set_state(Tango::ON);
		/*if(this->status.Flags & STATE_IS_HOMED)
			set_status("Homing performed");
		else
			set_status("Homing NOT performed");*/
		set_status("");
	}

}

/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::namespace_ending
} //	namespace
