/*----- PROTECTED REGION ID(Standa8SMC4StateMachine.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Standa8SMC4StateMachine.cpp,v 1.4 2016-11-11 09:39:26 graziano Exp $";
//=============================================================================
//
// file :        Standa8SMC4StateMachine.cpp
//
// description : State machine file for the Standa8SMC4 class
//
// project :     Standa 8SMC4
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: graziano $
//
// $Revision: 1.4 $
// $Date: 2016-11-11 09:39:26 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <Standa8SMC4.h>

/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::Standa8SMC4StateMachine.cpp

//================================================================
//  States  |  Description
//================================================================


namespace Standa8SMC4_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_Position_allowed()
 *	Description : Execution allowed for Position attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_Position_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Position attribute in Write access.
	/*----- PROTECTED REGION ID(Standa8SMC4::PositionStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::PositionStateAllowed_WRITE

	//	Not any excluded states for Position attribute in read access.
	/*----- PROTECTED REGION ID(Standa8SMC4::PositionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::PositionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_Acceleration_allowed()
 *	Description : Execution allowed for Acceleration attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_Acceleration_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Acceleration attribute in Write access.
	/*----- PROTECTED REGION ID(Standa8SMC4::AccelerationStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::AccelerationStateAllowed_WRITE

	//	Not any excluded states for Acceleration attribute in read access.
	/*----- PROTECTED REGION ID(Standa8SMC4::AccelerationStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::AccelerationStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_Accuracy_allowed()
 *	Description : Execution allowed for Accuracy attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_Accuracy_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Accuracy attribute in Write access.
	/*----- PROTECTED REGION ID(Standa8SMC4::AccuracyStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::AccuracyStateAllowed_WRITE

	//	Not any excluded states for Accuracy attribute in read access.
	/*----- PROTECTED REGION ID(Standa8SMC4::AccuracyStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::AccuracyStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_Position_home_allowed()
 *	Description : Execution allowed for Position_home attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_Position_home_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Position_home attribute in Write access.
	/*----- PROTECTED REGION ID(Standa8SMC4::Position_homeStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::Position_homeStateAllowed_WRITE

	//	Not any excluded states for Position_home attribute in read access.
	/*----- PROTECTED REGION ID(Standa8SMC4::Position_homeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::Position_homeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_Stat_allowed()
 *	Description : Execution allowed for Stat attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_Stat_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Stat attribute in read access.
	/*----- PROTECTED REGION ID(Standa8SMC4::StatStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::StatStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_EdgesStatus_allowed()
 *	Description : Execution allowed for EdgesStatus attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_EdgesStatus_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for EdgesStatus attribute in read access.
	/*----- PROTECTED REGION ID(Standa8SMC4::EdgesStatusStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::EdgesStatusStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_HomingConfig_allowed()
 *	Description : Execution allowed for HomingConfig attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_HomingConfig_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for HomingConfig attribute in read access.
	/*----- PROTECTED REGION ID(Standa8SMC4::HomingConfigStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::HomingConfigStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_Serialdevice_allowed()
 *	Description : Execution allowed for Serialdevice attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_Serialdevice_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Serialdevice attribute in read access.
	/*----- PROTECTED REGION ID(Standa8SMC4::SerialdeviceStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::SerialdeviceStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_SerialNumber_allowed()
 *	Description : Execution allowed for SerialNumber attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_SerialNumber_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SerialNumber attribute in read access.
	/*----- PROTECTED REGION ID(Standa8SMC4::SerialNumberStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::SerialNumberStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_StageName_allowed()
 *	Description : Execution allowed for StageName attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_StageName_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for StageName attribute in read access.
	/*----- PROTECTED REGION ID(Standa8SMC4::StageNameStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::StageNameStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_Speed_allowed()
 *	Description : Execution allowed for Speed attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_Speed_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Speed attribute in Write access.
	/*----- PROTECTED REGION ID(Standa8SMC4::SpeedStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::SpeedStateAllowed_WRITE

	//	Not any excluded states for Speed attribute in read access.
	/*----- PROTECTED REGION ID(Standa8SMC4::SpeedStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::SpeedStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_Forward_allowed()
 *	Description : Execution allowed for Forward attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_Forward_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Forward command.
	/*----- PROTECTED REGION ID(Standa8SMC4::ForwardStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::ForwardStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_Backward_allowed()
 *	Description : Execution allowed for Backward attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_Backward_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Backward command.
	/*----- PROTECTED REGION ID(Standa8SMC4::BackwardStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::BackwardStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_Stop_allowed()
 *	Description : Execution allowed for Stop attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_Stop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Stop command.
	/*----- PROTECTED REGION ID(Standa8SMC4::StopStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::StopStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_MotorOFF_allowed()
 *	Description : Execution allowed for MotorOFF attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_MotorOFF_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for MotorOFF command.
	/*----- PROTECTED REGION ID(Standa8SMC4::MotorOFFStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::MotorOFFStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_MotorON_allowed()
 *	Description : Execution allowed for MotorON attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_MotorON_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for MotorON command.
	/*----- PROTECTED REGION ID(Standa8SMC4::MotorONStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::MotorONStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_MotorSTANDBY_allowed()
 *	Description : Execution allowed for MotorSTANDBY attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_MotorSTANDBY_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for MotorSTANDBY command.
	/*----- PROTECTED REGION ID(Standa8SMC4::MotorSTANDBYStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::MotorSTANDBYStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_GoHome_allowed()
 *	Description : Execution allowed for GoHome attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_GoHome_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GoHome command.
	/*----- PROTECTED REGION ID(Standa8SMC4::GoHomeStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::GoHomeStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_SetHome_allowed()
 *	Description : Execution allowed for SetHome attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_SetHome_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SetHome command.
	/*----- PROTECTED REGION ID(Standa8SMC4::SetHomeStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::SetHomeStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_GoToPosition_allowed()
 *	Description : Execution allowed for GoToPosition attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_GoToPosition_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GoToPosition command.
	/*----- PROTECTED REGION ID(Standa8SMC4::GoToPositionStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::GoToPositionStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_FindEdge_allowed()
 *	Description : Execution allowed for FindEdge attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_FindEdge_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for FindEdge command.
	/*----- PROTECTED REGION ID(Standa8SMC4::FindEdgeStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::FindEdgeStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Standa8SMC4::is_SetHomeValue_allowed()
 *	Description : Execution allowed for SetHomeValue attribute
 */
//--------------------------------------------------------
bool Standa8SMC4::is_SetHomeValue_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SetHomeValue command.
	/*----- PROTECTED REGION ID(Standa8SMC4::SetHomeValueStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::SetHomeValueStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(Standa8SMC4::Standa8SMC4StateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	Standa8SMC4::Standa8SMC4StateAllowed.AdditionalMethods

}	//	End of namespace
